/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 11/26/2014
Author  : Zeus @ Sisoog.com
Company : Sisoog.com
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include "lcd/LCD_Driver.h"
#include "timer/timer.h"
#include "Finger/sm630.h"
#include <stdio.h>

// Declare your global variables here
uint8_t KeyStatus[4];
void Tim_ISR(void)
{
	static int i= 0;
	static int j= 0;

	if(i++>100)
	{
		i= 0;
		KeyStatus[0] = IS_Press(KEY1_Port,KEY1_Pin);
		KeyStatus[1] = IS_Press(KEY2_Port,KEY2_Pin);
		KeyStatus[2] = IS_Press(KEY3_Port,KEY3_Pin);
		KeyStatus[3] = IS_Press(KEY4_Port,KEY4_Pin);
	}
	if(j++>5000)
	{
		j = 0;
		LEDR_Set();
		delay_ms(3);
		LEDR_Clr();
	}
}

void main(void)
{
uint8_t resp;
uint8_t res;
uint8_t i;
uint16_t ID;
uint8_t Info[30]={0};   
    char lcdstr[30];
	uint8_t Tamper[22];

	LED_Init();
	Key_Init();
	RELE_Init();
	Timer_init(Tim_ISR);
	USART3_Config(57600);
	lcd_init();
    delay_ms(500);
	lcd_cls();
	delay_ms(100);
	sprintf(lcdstr,"Finger Ver:"); 
    lcd_gotoxy(0, 0)  ;
	lcd_puts(lcdstr);
	
	if(!finger_Read_info(Info))
	{     
        sprintf(lcdstr,"%s",Info);
        lcd_gotoxy(0, 1)  ;
		lcd_puts(lcdstr);
	}
	else
	{
        lcd_gotoxy(0, 1)  ;
		lcd_puts("Read Error");
		while(1);
	}
	delay_ms(3000);
	lcd_cls();
	delay_ms(100);
	  
      lcd_gotoxy(0, 0)  ;
		lcd_puts("Wait For Finger");
	
    
    
while(1)
    {

        uint8_t resp = finger_search(0,20,&ID);

        if(resp==0)
        {
            lcd_cls();
            delay_ms(100);
            sprintf(lcdstr,"Finger %i Valid",ID);
            lcd_gotoxy(0, 0)  ;
		    lcd_puts(lcdstr);
        
            Rele_Set();
            LEDG_Set();
            delay_ms(100);
			LEDG_Clr();
			Rele_Clr();
			delay_ms(1000);
		}
		else if(resp==Not_Found_Match_ID)
		{
			lcd_cls();
			delay_ms(100);
			sprintf(lcdstr,"Finger Not Valid");
            lcd_gotoxy(0, 0)  ;
		    lcd_puts(lcdstr) ;
			LEDR_Set();
			delay_ms(100);
			LEDR_Clr();
			delay_ms(1000);

		}


		if(KeyStatus[0]) /*Reg New Finger*/
		{
			lcd_cls();
			delay_ms(100);
			sprintf(lcdstr,"Reg Finger...");
			lcd_gotoxy(0, 0)  ;
		    lcd_puts(lcdstr) ;
            delay_ms(100);
			finger_Read_flash(0,Tamper,20);
			
			for(i=0;i<20;i++)
			{
				 if(Tamper[i]!=0xa5)
					 break;
			}

			if(i>20)
			{
				 sprintf(lcdstr,"Memory Is Full");
                 lcd_gotoxy(0, 1)  ;
		         lcd_puts(lcdstr) ;
				 delay_ms(2000);
			}
			else
			{
				Tamper[i] = 0xa5;
				res = finger_add(i);
				if(res==0)
				{
					finger_Write_flash(0,Tamper,20);
					sprintf(lcdstr,"Add in ID:%i->%i",i);
                    lcd_gotoxy(0, 1)  ;
		            lcd_puts(lcdstr);
				}
				else
				{
					sprintf(lcdstr,"Add Faild.");
                    lcd_gotoxy(0, 1)  ;
		            lcd_puts(lcdstr)  ;
				}
				delay_ms(2000);
			}
		}
		else if(KeyStatus[1]) /*Remove One Section*/
		{
			lcd_cls();
			delay_ms(100);
			sprintf(lcdstr,"Remove Finger...");
            lcd_gotoxy(0, 0)  ;
		    lcd_puts(lcdstr) ;
			delay_ms(100);
			resp = finger_search(0,20,&ID);
			if(resp==0)
			{
				finger_Read_flash(0,Tamper,20);
				Tamper[ID] = 0xFF; /*Free This*/
				if(!finger_delete(ID))
				{
					finger_Write_flash(0,Tamper,20);
					sprintf(lcdstr,"Remove %i Ok",ID);
                    lcd_gotoxy(0, 1)  ;
		            lcd_puts(lcdstr);
				}
				else
				{
					sprintf(lcdstr,"Remove Faild");
                    lcd_gotoxy(0, 1)  ;
		            lcd_puts(lcdstr);
				}
			}
			else
			{
				sprintf(lcdstr,"Remove Faild");
                lcd_gotoxy(0, 1)  ;
		        lcd_puts(lcdstr) ;
			}
			delay_ms(2000);
		}
		else if(KeyStatus[2])
		{
			lcd_cls();
			delay_ms(100);
			sprintf(lcdstr,"Remove All Finger");
            lcd_gotoxy(0, 0)  ;
		    lcd_puts(lcdstr) ;
			delay_ms(100);
			for(i=0;i<20;i++)
			{
				Tamper[i] = 0xFF;
				 sprintf(lcdstr,"RemoveID:%i->%i",i,finger_delete(i));
                 lcd_gotoxy(0, 1)  ;
		         lcd_puts(lcdstr) ;
				 delay_ms(100);
			}
			finger_Write_flash(0,Tamper,20);
		}


		lcd_cls();
		delay_ms(50);
        lcd_gotoxy(0, 0)  ;
		lcd_puts("Wait For Finger");
		//LEDR_Tog();
		delay_ms(50);
	}
}
