/*
 * Board.h
 *
 *  Created on: Oct 27, 2014
 *      Author: Zeus @ Sisoog.com
 */

#ifndef BOARD_H_
#define BOARD_H_

/*
 * LED Pin Config And Macro
 * */
#define LEDR_PIN		(1<<2)
#define LEDG_PIN		(1<<3)
#define LED_PORT		PORTD
#define LED_DDR			DDRD

#define LED_Init()		LED_DDR |=(LEDG_PIN|LEDR_PIN)
#define LEDR_Set()		LED_PORT |=LEDR_PIN
#define LEDR_Clr()		LED_PORT &=~LEDR_PIN
#define LEDR_Tog()		LED_PORT ^=LEDR_PIN

#define LEDG_Set()		LED_PORT |=LEDG_PIN
#define LEDG_Clr()		LED_PORT &=~LEDG_PIN
#define LEDG_Tog()		LED_PORT ^=LEDG_PIN

/*
 * Key Pin Config And Macro
 * */
#define KEY1_Pin		(1<<5)
#define KEY2_Pin		(1<<6)
#define KEY3_Pin		(1<<7)
#define KEY4_Pin		(1<<0)

#define KEY1_Port		PIND
#define KEY2_Port		PIND
#define KEY3_Port		PIND
#define KEY4_Port		PINB

#define Key_Init()		{DDRD&=~(KEY1_Pin|KEY2_Pin|KEY3_Pin); DDRB&=~(KEY4_Pin);PORTD|=(KEY1_Pin|KEY2_Pin|KEY3_Pin);PORTB|=KEY4_Pin;};

#define IS_Press(PORT,PIN)	((PORT&PIN)==0)

/*
 * Rele Pin Config And Macro
 * */
#define RELE_Pin		(1<<1)
#define RELE_Port		PORTB
#define RELE_Init()		{DDRB|=RELE_Pin;}
#define Rele_Set()		RELE_Port|=RELE_Pin;
#define Rele_Clr()		RELE_Port&=~RELE_Pin;
#endif /* BOARD_H_ */
