/*
 * Guart.c
 *
 *  Created on: Sep 10, 2014
 *      Author: Zeus @ Sisoog.com
 */

#include <string.h>
#include "Board.h"

// Define baud rate
#define USART_BAUDRATE 57600
#define BAUD_PRESCALE (((8000000 / (USART_BAUDRATE * 16UL))) - 1)




char rx3_buffer[RX3_BUFFER_SIZE];
volatile unsigned int rx3_wr_index,rx3_rd_index,rx3_counter;
volatile char rx3_buffer_overflow;


interrupt [USART_RXC] void usart_rx_isr(void)
{
	//LEDG_Tog();
  {
   char data = UDR;
   //putchar(data);
   rx3_buffer[rx3_wr_index++]=data;
   if (rx3_wr_index == RX3_BUFFER_SIZE) rx3_wr_index=0;
   if (++rx3_counter == RX3_BUFFER_SIZE)
      {
      rx3_counter=0;
      rx3_buffer_overflow=1;
      }
  }
}


void USART3_Free_Buffer(void)
{
  memset(rx3_buffer,0,RX3_BUFFER_SIZE);
  rx3_wr_index = rx3_rd_index =  rx3_counter = 0;
  rx3_buffer_overflow = 0;
}


void USART3_Config(int Baud)
{
   // Set baud rate
   UBRRL = BAUD_PRESCALE;// Load lower 8-bits into the low byte of the UBRR register
   UBRRH = (BAUD_PRESCALE >> 8);
   /* Load upper 8-bits into the high byte of the UBRR register
   Default frame format is 8 data bits, no parity, 1 stop bit
   to change use UCSRC, see AVR datasheet*/

  // Enable receiver and transmitter and receive complete interrupt
  UCSRB = ((1<<TXEN)|(1<<RXEN) | (1<<RXCIE));
  UCSRC|= (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);   // 8bit data format


}


//int Gputchar(int c)
//{
////	while(USART_GetFlagStatus(USART3, USART_FLAG_TXE) == RESET);
////	USART_SendData(USART3, c);
////	while(!(USART3->SR&(1<<6))|| !(USART3->SR&(1<<7)));	// Wait Redy Uart
////	return c;
//}

void Uart3_Send(char Data)
{
	// Wait until last byte has been transmitted
	while((UCSRA &(1<<UDRE)) == 0);
	// Transmit data
    UDR = Data;
}


char Uart3_Get(void)
{
char data;
  while (rx3_counter==0);
  data=rx3_buffer[rx3_rd_index++];
  if (rx3_rd_index == RX3_BUFFER_SIZE) rx3_rd_index=0;
  --rx3_counter;
return data;
}


char Uart3_Get_char(char *Data)
{
char data;
  if(rx3_counter==0) return 0;
  data=rx3_buffer[rx3_rd_index++];
  if (rx3_rd_index == RX3_BUFFER_SIZE) rx3_rd_index=0;
  --rx3_counter;
  *Data = data;
return 1;
}
