
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 300 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x012C
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _LCD_Pin_Data=R5
	.DEF _ISR_CallBack=R6
	.DEF _ISR_CallBack_msb=R7

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_comp_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _usart_rx_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0

_0x7:
	.DB  0x0,0x8,0x4,0xC,0x2,0xA,0x6,0xE
	.DB  0x1,0x9,0x5,0xD,0x3,0xB,0x7,0xF
_0x8:
	.DB  0x1F,0x15,0x15,0xE,0x4,0x4,0x4,0x0
	.DB  0x0,0x10,0x8,0x4,0x2,0x1,0x0,0x0
_0x34:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_0x3B:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
_0x3E:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
_0x6A:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0
_0x0:
	.DB  0x46,0x69,0x6E,0x67,0x65,0x72,0x20,0x56
	.DB  0x65,0x72,0x3A,0x0,0x25,0x73,0x0,0x52
	.DB  0x65,0x61,0x64,0x20,0x45,0x72,0x72,0x6F
	.DB  0x72,0x0,0x57,0x61,0x69,0x74,0x20,0x46
	.DB  0x6F,0x72,0x20,0x46,0x69,0x6E,0x67,0x65
	.DB  0x72,0x0,0x46,0x69,0x6E,0x67,0x65,0x72
	.DB  0x20,0x25,0x69,0x20,0x56,0x61,0x6C,0x69
	.DB  0x64,0x0,0x46,0x69,0x6E,0x67,0x65,0x72
	.DB  0x20,0x4E,0x6F,0x74,0x20,0x56,0x61,0x6C
	.DB  0x69,0x64,0x0,0x52,0x65,0x67,0x20,0x46
	.DB  0x69,0x6E,0x67,0x65,0x72,0x2E,0x2E,0x2E
	.DB  0x0,0x4D,0x65,0x6D,0x6F,0x72,0x79,0x20
	.DB  0x49,0x73,0x20,0x46,0x75,0x6C,0x6C,0x0
	.DB  0x41,0x64,0x64,0x20,0x69,0x6E,0x20,0x49
	.DB  0x44,0x3A,0x25,0x69,0x2D,0x3E,0x25,0x69
	.DB  0x0,0x41,0x64,0x64,0x20,0x46,0x61,0x69
	.DB  0x6C,0x64,0x2E,0x0,0x52,0x65,0x6D,0x6F
	.DB  0x76,0x65,0x20,0x46,0x69,0x6E,0x67,0x65
	.DB  0x72,0x2E,0x2E,0x2E,0x0,0x52,0x65,0x6D
	.DB  0x6F,0x76,0x65,0x20,0x25,0x69,0x20,0x4F
	.DB  0x6B,0x0,0x52,0x65,0x6D,0x6F,0x76,0x65
	.DB  0x20,0x46,0x61,0x69,0x6C,0x64,0x0,0x52
	.DB  0x65,0x6D,0x6F,0x76,0x65,0x20,0x41,0x6C
	.DB  0x6C,0x20,0x46,0x69,0x6E,0x67,0x65,0x72
	.DB  0x0,0x52,0x65,0x6D,0x6F,0x76,0x65,0x49
	.DB  0x44,0x3A,0x25,0x69,0x2D,0x3E,0x25,0x69
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x05
	.DW  __REG_VARS*2

	.DW  0x0B
	.DW  _0x6D
	.DW  _0x0*2+15

	.DW  0x10
	.DW  _0x6D+11
	.DW  _0x0*2+26

	.DW  0x10
	.DW  _0x6D+27
	.DW  _0x0*2+26

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x18C

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
; Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 11/26/2014
;Author  : Zeus @ Sisoog.com
;Company : Sisoog.com
;Comments:
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 8.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include "lcd/LCD_Driver.h"
;/*
; * Lcd_Driver.c
; *
; *  Created on: Sep 9, 2014
; *      Author: Zeus @ Sisoog.com
; */
;#include "Latch_595_Driver.c"
;/*
; * Latch_595_Driver.c
; *
; *  Created on: Sep 9, 2014
; *      Author: Zeus @ Sisoog.com
; */
;
;#include "Latch_595_Driver.h"
;
;
;
;
;void Init_Latch(void)
; 0000 0019 {

	.CSEG
_Init_Latch:
; .FSTART _Init_Latch
;	DDRC = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;	Latch_Put(0);
	LDI  R26,LOW(0)
	RCALL _Latch_Put
;}
	RET
; .FEND
;
;
;void Latch_Put(uint8_t Data)
;{
_Latch_Put:
; .FSTART _Latch_Put
;	PORTC = Data;
	ST   -Y,R26
;	Data -> Y+0
	LD   R30,Y
	OUT  0x15,R30
;}
	RJMP _0x206000E
; .FEND
;#include <delay.h>
;
;
;
;
;uint8_t LCD_Pin_Data=0;
;
;#define delay_us(x)		delay_us(x)
;#define delay_ms(x)		delay_ms(x)
;
;
;
;#define LCD_LINE0_DDRAMADDR		0x00
;#define LCD_LINE1_DDRAMADDR		0x40
;#define LCD_LINE2_DDRAMADDR		0x14
;#define LCD_LINE3_DDRAMADDR		0x54
;#define LCD_DDRAM           7      // DB7: set DD RAM address
;#define LCD_CGRAM           6      // DB6: set CG RAM address
;#define LCD_CLR             0      // DB0: clear display
;#define LCD_HOME            1      // DB1: return to home position
;
;/*
;void delay_us(int x)
;{
;	volatile int i;
;	for(i=0;i<1000*x;i++);
;}
;*/
;
;
;void SetLCD_RW(uint8_t stat)
;{
_SetLCD_RW:
; .FSTART _SetLCD_RW
;
;}
	RET
; .FEND
;
;
;void SetLCD_RS(uint8_t stat)
;{
_SetLCD_RS:
; .FSTART _SetLCD_RS
;	if(stat==0)
	ST   -Y,R26
;	stat -> Y+0
	RCALL SUBOPT_0x0
	BRNE _0x3
;	{
;		LCD_Pin_Data &= ~LCD_RS;
	LDI  R30,LOW(223)
	AND  R5,R30
;	}
;	else
	RJMP _0x4
_0x3:
;	{
;		LCD_Pin_Data |= LCD_RS;
	LDI  R30,LOW(32)
	OR   R5,R30
;	}
_0x4:
;	Latch_Put(LCD_Pin_Data);
	MOV  R26,R5
	RCALL _Latch_Put
;}
	RJMP _0x206000E
; .FEND
;
;
;void SetLCD_EN(uint8_t stat)
;{
_SetLCD_EN:
; .FSTART _SetLCD_EN
;	if(stat==0)
	ST   -Y,R26
;	stat -> Y+0
	RCALL SUBOPT_0x0
	BRNE _0x5
;	{
;		LCD_Pin_Data &= ~LCD_EN;
	LDI  R30,LOW(239)
	AND  R5,R30
;	}
;	else
	RJMP _0x6
_0x5:
;	{
;		LCD_Pin_Data |= LCD_EN;
	LDI  R30,LOW(16)
	OR   R5,R30
;	}
_0x6:
;	Latch_Put(LCD_Pin_Data);
	MOV  R26,R5
	RCALL _Latch_Put
;}
	RJMP _0x206000E
; .FEND
;
;void SetLCD_Data(uint8_t Data)
;{
_SetLCD_Data:
; .FSTART _SetLCD_Data
;	uint8_t lookup[16] =
;	{
;	   0x0, 0x8, 0x4, 0xC,0x2, 0xA, 0x6, 0xE,
;	   0x1, 0x9, 0x5, 0xD,0x3, 0xB, 0x7, 0xF
;	};
;
;	Data = (Data&0x0F);
	ST   -Y,R26
	RCALL SUBOPT_0x1
	LDI  R30,LOW(_0x7*2)
	LDI  R31,HIGH(_0x7*2)
	RCALL __INITLOCB
;	Data -> Y+16
;	lookup -> Y+0
	LDD  R30,Y+16
	ANDI R30,LOW(0xF)
	STD  Y+16,R30
;
;	LCD_Pin_Data &=0xF0;
	LDI  R30,LOW(240)
	AND  R5,R30
;	LCD_Pin_Data |= lookup[Data];
	LDD  R30,Y+16
	LDI  R31,0
	MOVW R26,R28
	RCALL SUBOPT_0x2
	LD   R30,X
	OR   R5,R30
;	Latch_Put(LCD_Pin_Data);
	MOV  R26,R5
	RCALL _Latch_Put
;}
	ADIW R28,17
	RET
; .FEND
;
;
;void LCD_STROBE(void)
;{
_LCD_STROBE:
; .FSTART _LCD_STROBE
;	SetLCD_EN(1);
	LDI  R26,LOW(1)
	RCALL SUBOPT_0x3
;	delay_us(10);
;	SetLCD_EN(0);
	LDI  R26,LOW(0)
	RCALL SUBOPT_0x3
;	delay_us(10);
;}
	RET
; .FEND
;
;void lcd_write_byte (char Value)
;{
_lcd_write_byte:
; .FSTART _lcd_write_byte
;	char upperNibble = Value >> 4;
;	char lowerNibble = Value & 0x0F;
;
;	SetLCD_Data(upperNibble);
	ST   -Y,R26
	RCALL __SAVELOCR2
;	Value -> Y+2
;	upperNibble -> R17
;	lowerNibble -> R16
	LDD  R30,Y+2
	SWAP R30
	ANDI R30,0xF
	MOV  R17,R30
	LDD  R30,Y+2
	ANDI R30,LOW(0xF)
	MOV  R16,R30
	MOV  R26,R17
	RCALL _SetLCD_Data
;	LCD_STROBE();
	RCALL _LCD_STROBE
;
;	SetLCD_Data(lowerNibble);
	MOV  R26,R16
	RCALL _SetLCD_Data
;	LCD_STROBE();
	RCALL _LCD_STROBE
;
;}
	RCALL __LOADLOCR2
	RJMP _0x206000D
; .FEND
;
;void lcd_command(char cmd)
;{
_lcd_command:
; .FSTART _lcd_command
;		SetLCD_RS(0);
	ST   -Y,R26
;	cmd -> Y+0
	LDI  R26,LOW(0)
	RCALL SUBOPT_0x4
;		delay_us(10);
;		lcd_write_byte(cmd);
;}
	RJMP _0x206000E
; .FEND
;
;void lcd_data(char ch)
;{
_lcd_data:
; .FSTART _lcd_data
;	SetLCD_RS(1);//LCD_RS_HI;
	ST   -Y,R26
;	ch -> Y+0
	LDI  R26,LOW(1)
	RCALL SUBOPT_0x4
;	delay_us(10);
;	lcd_write_byte(ch);
;}
	RJMP _0x206000E
; .FEND
;
;
;void lcd_init(void)
;{
_lcd_init:
; .FSTART _lcd_init
;	char cchar[]={0x00,0x10,0x08,0x04,0x02,0x01,0x00,0x00};
;	char achar[]={0x1F,0x15,0x15,0x0E,0x04,0x04,0x04,0x00};
;
;	Init_Latch();
	RCALL SUBOPT_0x1
	LDI  R30,LOW(_0x8*2)
	LDI  R31,HIGH(_0x8*2)
	RCALL __INITLOCB
;	cchar -> Y+8
;	achar -> Y+0
	RCALL _Init_Latch
;	SetLCD_RW(0); /*Always Write To Lcd*/
	LDI  R26,LOW(0)
	RCALL _SetLCD_RW
;
;	delay_ms(15);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
;	lcd_command(0x30);
;	delay_ms(4);
	LDI  R26,LOW(4)
	LDI  R27,0
	RCALL SUBOPT_0x6
;	lcd_command(0x30);
;	delay_ms(1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x6
;	lcd_command(0x30);
;	delay_ms(1);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
;	lcd_command(0x02);
;	delay_ms(1);
	RCALL _delay_ms
;
;
;	lcd_command(0x28);delay_ms(1); // configuring LCD as 2 line 5x7 matrix in 4-bit mode
	LDI  R26,LOW(40)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
;	lcd_command(0x0C);delay_ms(1);
	LDI  R26,LOW(12)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
;	lcd_command(0x08);delay_ms(1);
	LDI  R26,LOW(8)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
;	lcd_command(0x01);delay_ms(1);
	LDI  R26,LOW(1)
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
;	lcd_command(0x02);delay_ms(1);
	RCALL _delay_ms
;	//lcd_command(0x06);
;	lcd_command(0x0c);delay_ms(1); // Display on, Cursor blinking
	LDI  R26,LOW(12)
	RCALL SUBOPT_0x9
	RCALL _delay_ms
;
;	lcd_LoadCustomChar(cchar,1);
	MOVW R30,R28
	ADIW R30,8
	RCALL SUBOPT_0xA
	LDI  R26,LOW(1)
	RCALL _lcd_LoadCustomChar
;	lcd_LoadCustomChar(achar,2);
	RCALL SUBOPT_0xB
	LDI  R26,LOW(2)
	RCALL _lcd_LoadCustomChar
;}
	ADIW R28,16
	RET
; .FEND
;
;void lcd_gotoxy(char x, char y)
;{
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
;	register char DDRAMAddr;
;
;	// remap lines into proper order
;	switch(y)
	ST   -Y,R26
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	DDRAMAddr -> R17
	LDD  R30,Y+1
	LDI  R31,0
;	{
;	case 0: DDRAMAddr = LCD_LINE0_DDRAMADDR+x; break;
	SBIW R30,0
	BREQ _0x8C
;	case 1: DDRAMAddr = LCD_LINE1_DDRAMADDR+x; break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xD
	LDD  R30,Y+2
	SUBI R30,-LOW(64)
	RJMP _0x8D
;	case 2: DDRAMAddr = LCD_LINE2_DDRAMADDR+x; break;
_0xD:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xE
	LDD  R30,Y+2
	SUBI R30,-LOW(20)
	RJMP _0x8D
;	case 3: DDRAMAddr = LCD_LINE3_DDRAMADDR+x; break;
_0xE:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x10
	LDD  R30,Y+2
	SUBI R30,-LOW(84)
	RJMP _0x8D
;	default: DDRAMAddr = LCD_LINE0_DDRAMADDR+x;
_0x10:
_0x8C:
	LDD  R30,Y+2
_0x8D:
	MOV  R17,R30
;	}
;
;	// set data address
;	lcd_command(1<<LCD_DDRAM | DDRAMAddr);
	ORI  R30,0x80
	MOV  R26,R30
	RCALL _lcd_command
;}
	RJMP _0x206000C
; .FEND
;
;void lcd_Home(void)
;{
;	// move cursor to home
;	lcd_command(1<<LCD_HOME);
;}
;
;void lcd_cls(void)
;{
_lcd_cls:
; .FSTART _lcd_cls
;	// clear LCD
;	lcd_command(1<<LCD_CLR);
	LDI  R26,LOW(1)
	RCALL _lcd_command
;}
	RET
; .FEND
;
;void lcd_LoadCustomChar(char* lcdCustomCharArray, char lcdCharNum)
;{
_lcd_LoadCustomChar:
; .FSTART _lcd_LoadCustomChar
;	char i;
;
;	// multiply the character index by 8
;	lcdCharNum = (lcdCharNum<<3);	// each character occupies 8 bytes
	ST   -Y,R26
	ST   -Y,R17
;	*lcdCustomCharArray -> Y+2
;	lcdCharNum -> Y+1
;	i -> R17
	LDD  R30,Y+1
	LSL  R30
	LSL  R30
	LSL  R30
	STD  Y+1,R30
;
;	// copy the 8 bytes into CG (character generator) RAM
;	for(i=0; i<8; i++)
	LDI  R17,LOW(0)
_0x12:
	CPI  R17,8
	BRSH _0x13
;	{
;		// set CG RAM address
;		lcd_command((1<<LCD_CGRAM) | (lcdCharNum+i));
	MOV  R30,R17
	LDD  R26,Y+1
	ADD  R30,R26
	ORI  R30,0x40
	MOV  R26,R30
	RCALL _lcd_command
;		// write character data
;		lcd_data(*(lcdCustomCharArray+i));
	MOV  R30,R17
	LDI  R31,0
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x2
	LD   R26,X
	RCALL _lcd_data
;	}
	SUBI R17,-1
	RJMP _0x12
_0x13:
;	lcd_gotoxy(0,0);
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
;}
	LDD  R17,Y+0
	ADIW R28,4
	RET
; .FEND
;
;void lcd_putc(char c)
;{
;   lcd_data(c);
;	c -> Y+0
;}
;
;void lcd_puts(char* data)
;{
_lcd_puts:
; .FSTART _lcd_puts
;	while(*data!=0){
	RCALL SUBOPT_0xF
;	*data -> Y+0
_0x14:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x16
;		lcd_data(*data++);
	LD   R30,X+
	ST   Y,R26
	STD  Y+1,R27
	MOV  R26,R30
	RCALL _lcd_data
;		}
	RJMP _0x14
_0x16:
;}
	RJMP _0x206000F
; .FEND
;
;#include "timer/timer.h"
;/*
; * Timer.c
; *
; *  Created on: Oct 31, 2014
; *      Author: Zeus @ Sisoog.com
; */
;
;#include <stdint.h>
;
;void (*ISR_CallBack)(void);
;volatile uint32_t SYSTime = 0;
;
;interrupt [TIM2_COMP] void timer2_comp_isr(void)
; 0000 001A {
_timer2_comp_isr:
; .FSTART _timer2_comp_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;	static uint8_t TFix = 0;
;	if(TFix++>10)
	LDS  R26,_TFix_S0000011000
	SUBI R26,-LOW(1)
	STS  _TFix_S0000011000,R26
	SUBI R26,LOW(1)
	CPI  R26,LOW(0xB)
	BRLO _0x17
;	{
;		TFix = 0;
	LDI  R30,LOW(0)
	STS  _TFix_S0000011000,R30
;		SYSTime++;
	LDI  R26,LOW(_SYSTime)
	LDI  R27,HIGH(_SYSTime)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
;	}
;	if(ISR_CallBack)
_0x17:
	MOV  R0,R6
	OR   R0,R7
	BREQ _0x18
;		ISR_CallBack();
	MOVW R30,R6
	ICALL
;}
_0x18:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;
;
;void Timer_init(void (*CallBack)(void))
;{
_Timer_init:
; .FSTART _Timer_init
;	ISR_CallBack = CallBack;
	RCALL SUBOPT_0xF
;	*CallBack -> Y+0
	__GETWRS 6,7,0
;
;	// set timer0 counter initial value to 0
;	TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;	OCR2 = 0x2A;
	LDI  R30,LOW(42)
	OUT  0x23,R30
;
;	// start timer2 with /1024 prescaler
;	TCCR2 = (1 << WGM21) | (1<<CS22) | (1<<CS20);
	LDI  R30,LOW(13)
	OUT  0x25,R30
;
;	// enable timer CTC interrupt for Timer0
;	TIMSK=(1<<OCIE2);
	LDI  R30,LOW(128)
	OUT  0x39,R30
;}
	RJMP _0x206000F
; .FEND
;#include "Finger/sm630.h"
;/*
; * SM630.c
; *
; *  Created on: Sep 11, 2014
; *      Author: Zeus @ Sisoog.com
; */
;
;#include <stdint.h>
;#include "Uart.h"
;/*
; * Guart.c
; *
; *  Created on: Sep 10, 2014
; *      Author: Zeus @ Sisoog.com
; */
;
;#include <string.h>
;#include "Board.h"
;
;// Define baud rate
;#define USART_BAUDRATE 57600
;#define BAUD_PRESCALE (((8000000 / (USART_BAUDRATE * 16UL))) - 1)
;
;
;
;
;char rx3_buffer[RX3_BUFFER_SIZE];
;volatile unsigned int rx3_wr_index,rx3_rd_index,rx3_counter;
;volatile char rx3_buffer_overflow;
;
;
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 001B {
_usart_rx_isr:
; .FSTART _usart_rx_isr
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;	//LEDG_Tog();
;  {
;   char data = UDR;
;   //putchar(data);
;   rx3_buffer[rx3_wr_index++]=data;
	SBIW R28,1
;	data -> Y+0
	IN   R30,0xC
	ST   Y,R30
	LDI  R26,LOW(_rx3_wr_index)
	LDI  R27,HIGH(_rx3_wr_index)
	RCALL SUBOPT_0x10
	SBIW R30,1
	SUBI R30,LOW(-_rx3_buffer)
	SBCI R31,HIGH(-_rx3_buffer)
	LD   R26,Y
	STD  Z+0,R26
;   if (rx3_wr_index == RX3_BUFFER_SIZE) rx3_wr_index=0;
	LDS  R26,_rx3_wr_index
	LDS  R27,_rx3_wr_index+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE _0x19
	LDI  R30,LOW(0)
	STS  _rx3_wr_index,R30
	STS  _rx3_wr_index+1,R30
;   if (++rx3_counter == RX3_BUFFER_SIZE)
_0x19:
	LDI  R26,LOW(_rx3_counter)
	LDI  R27,HIGH(_rx3_counter)
	RCALL SUBOPT_0x10
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x1A
;      {
;      rx3_counter=0;
	LDI  R30,LOW(0)
	STS  _rx3_counter,R30
	STS  _rx3_counter+1,R30
;      rx3_buffer_overflow=1;
	LDI  R30,LOW(1)
	STS  _rx3_buffer_overflow,R30
;      }
;  }
_0x1A:
	ADIW R28,1
;}
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;
;void USART3_Free_Buffer(void)
;{
;  memset(rx3_buffer,0,RX3_BUFFER_SIZE);
;  rx3_wr_index = rx3_rd_index =  rx3_counter = 0;
;  rx3_buffer_overflow = 0;
;}
;
;
;void USART3_Config(int Baud)
;{
_USART3_Config:
; .FSTART _USART3_Config
;   // Set baud rate
;   UBRRL = BAUD_PRESCALE;// Load lower 8-bits into the low byte of the UBRR register
	RCALL SUBOPT_0xF
;	Baud -> Y+0
	LDI  R30,LOW(7)
	OUT  0x9,R30
;   UBRRH = (BAUD_PRESCALE >> 8);
	LDI  R30,LOW(0)
	OUT  0x20,R30
;   /* Load upper 8-bits into the high byte of the UBRR register
;   Default frame format is 8 data bits, no parity, 1 stop bit
;   to change use UCSRC, see AVR datasheet*/
;
;  // Enable receiver and transmitter and receive complete interrupt
;  UCSRB = ((1<<TXEN)|(1<<RXEN) | (1<<RXCIE));
	LDI  R30,LOW(152)
	OUT  0xA,R30
;  UCSRC|= (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);   // 8bit data format
	IN   R30,0x20
	ORI  R30,LOW(0x86)
	OUT  0x20,R30
;
;
;}
_0x206000F:
	ADIW R28,2
	RET
; .FEND
;
;
;//int Gputchar(int c)
;//{
;////	while(USART_GetFlagStatus(USART3, USART_FLAG_TXE) == RESET);
;////	USART_SendData(USART3, c);
;////	while(!(USART3->SR&(1<<6))|| !(USART3->SR&(1<<7)));	// Wait Redy Uart
;////	return c;
;//}
;
;void Uart3_Send(char Data)
;{
_Uart3_Send:
; .FSTART _Uart3_Send
;	// Wait until last byte has been transmitted
;	while((UCSRA &(1<<UDRE)) == 0);
	ST   -Y,R26
;	Data -> Y+0
_0x1B:
	SBIS 0xB,5
	RJMP _0x1B
;	// Transmit data
;    UDR = Data;
	LD   R30,Y
	OUT  0xC,R30
;}
_0x206000E:
	ADIW R28,1
	RET
; .FEND
;
;
;char Uart3_Get(void)
;{
;char data;
;  while (rx3_counter==0);
;	data -> R17
;  data=rx3_buffer[rx3_rd_index++];
;  if (rx3_rd_index == RX3_BUFFER_SIZE) rx3_rd_index=0;
;  --rx3_counter;
;return data;
;}
;
;
;char Uart3_Get_char(char *Data)
;{
_Uart3_Get_char:
; .FSTART _Uart3_Get_char
;char data;
;  if(rx3_counter==0) return 0;
	RCALL SUBOPT_0xF
	ST   -Y,R17
;	*Data -> Y+1
;	data -> R17
	LDS  R30,_rx3_counter
	LDS  R31,_rx3_counter+1
	SBIW R30,0
	BRNE _0x22
	LDI  R30,LOW(0)
	RJMP _0x206000C
;  data=rx3_buffer[rx3_rd_index++];
_0x22:
	LDI  R26,LOW(_rx3_rd_index)
	LDI  R27,HIGH(_rx3_rd_index)
	RCALL SUBOPT_0x10
	SBIW R30,1
	SUBI R30,LOW(-_rx3_buffer)
	SBCI R31,HIGH(-_rx3_buffer)
	LD   R17,Z
;  if (rx3_rd_index == RX3_BUFFER_SIZE) rx3_rd_index=0;
	LDS  R26,_rx3_rd_index
	LDS  R27,_rx3_rd_index+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE _0x23
	LDI  R30,LOW(0)
	STS  _rx3_rd_index,R30
	STS  _rx3_rd_index+1,R30
;  --rx3_counter;
_0x23:
	LDI  R26,LOW(_rx3_counter)
	LDI  R27,HIGH(_rx3_counter)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
;  *Data = data;
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ST   X,R17
;return 1;
	LDI  R30,LOW(1)
_0x206000C:
	LDD  R17,Y+0
_0x206000D:
	ADIW R28,3
	RET
;}
; .FEND
;#include "SM630.h"
;#include <string.h>
;
;
;#define SM_SEND(x)		Uart3_Send(x)
;#define SM_Get()		Uart3_Get();
;
;
;
;int OS_GetTime(void)
;{
_OS_GetTime:
; .FSTART _OS_GetTime
;	extern volatile uint32_t SYSTime;
;	return SYSTime;
	LDS  R30,_SYSTime
	LDS  R31,_SYSTime+1
	RET
;}
; .FEND
;
;uint8_t finger_Get_pack(uint8_t *buffer,uint8_t Max_Len,uint32_t TimeOut)
;{
_finger_Get_pack:
; .FSTART _finger_Get_pack
;	uint32_t Start_Time = OS_GetTime();
;	uint8_t phase = 0;
;	uint8_t Write_index = 0;
;
;
;	while((OS_GetTime()-Start_Time)<TimeOut)
	RCALL __PUTPARD2
	SBIW R28,4
	RCALL __SAVELOCR2
;	*buffer -> Y+11
;	Max_Len -> Y+10
;	TimeOut -> Y+6
;	Start_Time -> Y+2
;	phase -> R17
;	Write_index -> R16
	RCALL _OS_GetTime
	RCALL __CWD1
	__PUTD1S 2
	LDI  R17,0
	LDI  R16,0
_0x24:
	RCALL _OS_GetTime
	MOVW R26,R30
	__GETD1S 2
	RCALL __CWD2
	RCALL __SUBD21
	__GETD1S 6
	RCALL __CPD21
	BRLO PC+2
	RJMP _0x26
;	{
;		char Data;
;		if(Uart3_Get_char(&Data))
	SBIW R28,1
;	*buffer -> Y+12
;	Max_Len -> Y+11
;	TimeOut -> Y+7
;	Start_Time -> Y+3
;	Data -> Y+0
	MOVW R26,R28
	RCALL _Uart3_Get_char
	CPI  R30,0
	BREQ _0x27
;		{
;			switch(phase+2)
	MOV  R30,R17
	LDI  R31,0
	ADIW R30,2
;			{
;			case 0:
	SBIW R30,0
	BRNE _0x2B
;				if(Data==0x4D)
	LD   R26,Y
	CPI  R26,LOW(0x4D)
	BRNE _0x2C
;					phase = 1;
	LDI  R17,LOW(1)
;				break;
_0x2C:
	RJMP _0x2A
;			case 1:
_0x2B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2D
;				if(Data==0x58)
	LD   R26,Y
	CPI  R26,LOW(0x58)
	BRNE _0x2E
;				{
;					phase = 2;
	LDI  R17,LOW(2)
;					buffer[0] = 0x45;
	RCALL SUBOPT_0x11
	LDI  R30,LOW(69)
	ST   X,R30
;					buffer[1] = 0x58;
	RCALL SUBOPT_0x11
	ADIW R26,1
	LDI  R30,LOW(88)
	ST   X,R30
;				}
;				else
	RJMP _0x2F
_0x2E:
;					phase = 0;
	LDI  R17,LOW(0)
;				break;
_0x2F:
	RJMP _0x2A
;			case 2:
_0x2D:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2A
;				buffer[2+Write_index] = Data;
	MOV  R30,R16
	LDI  R31,0
	ADIW R30,2
	RCALL SUBOPT_0x11
	ADD  R30,R26
	ADC  R31,R27
	LD   R26,Y
	STD  Z+0,R26
;				if(Write_index>1 && buffer[8+1]<=(Write_index-0xA))
	CPI  R16,2
	BRLO _0x32
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	LDD  R26,Z+9
	MOV  R30,R16
	LDI  R31,0
	SBIW R30,10
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x33
_0x32:
	RJMP _0x31
_0x33:
;				{
;					return 0;
	LDI  R30,LOW(0)
	ADIW R28,1
	RJMP _0x206000B
;				}
;				Write_index++;
_0x31:
	SUBI R16,-1
;			}
_0x2A:
;		}
;	}
_0x27:
	ADIW R28,1
	RJMP _0x24
_0x26:
;	return 1;
	LDI  R30,LOW(1)
_0x206000B:
	RCALL __LOADLOCR2
	ADIW R28,13
	RET
;}
; .FEND
;
;uint8_t finger_send_Command(SM_Command cmd,uint8_t *Data,uint8_t Data_len)
;{
_finger_send_Command:
; .FSTART _finger_send_Command
;    int i;
;    uint8_t Buf[20] ={0};
;	uint8_t	sum = 0xB6;
;	Data_len++;
	ST   -Y,R26
	SBIW R28,20
	LDI  R24,20
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x34*2)
	LDI  R31,HIGH(_0x34*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR4
;	cmd -> Y+27
;	*Data -> Y+25
;	Data_len -> Y+24
;	i -> R16,R17
;	Buf -> Y+4
;	sum -> R19
	LDI  R19,182
	LDD  R30,Y+24
	SUBI R30,-LOW(1)
	STD  Y+24,R30
;
;	SM_SEND(0x4D);
	LDI  R26,LOW(77)
	RCALL _Uart3_Send
;	SM_SEND(0x58);
	LDI  R26,LOW(88)
	RCALL _Uart3_Send
;	SM_SEND(0x10); /*For Packet*/
	LDI  R26,LOW(16)
	RCALL _Uart3_Send
;	SM_SEND(Data_len);
	LDD  R26,Y+24
	RCALL _Uart3_Send
;	sum+=Data_len;
	LDD  R30,Y+24
	ADD  R19,R30
;	SM_SEND(cmd);
	LDD  R26,Y+27
	RCALL _Uart3_Send
;	sum+=cmd;
	LDD  R30,Y+27
	ADD  R19,R30
;	for(i=0;i<Data_len-8;i++)
	__GETWRN 16,17,0
_0x36:
	LDD  R30,Y+24
	LDI  R31,0
	SBIW R30,8
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x37
;	{
;		SM_SEND(Data[i]);
	RCALL SUBOPT_0x12
	LD   R26,X
	RCALL _Uart3_Send
;		sum+=Data[i];
	RCALL SUBOPT_0x12
	LD   R30,X
	ADD  R19,R30
;	}
	__ADDWRN 16,17,1
	RJMP _0x36
_0x37:
;	SM_SEND(sum);
	MOV  R26,R19
	RCALL _Uart3_Send
;
;
;
;	if(finger_Get_pack(Buf,15,200)==0 && Buf[4]==0x01)
	MOVW R30,R28
	ADIW R30,4
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
	BRNE _0x39
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	BREQ _0x3A
_0x39:
	RJMP _0x38
_0x3A:
;		return 0;
	LDI  R30,LOW(0)
	RJMP _0x206000A
;	return 1;
_0x38:
	LDI  R30,LOW(1)
_0x206000A:
	RCALL __LOADLOCR4
	ADIW R28,28
	RET
;}
; .FEND
;
;
;uint8_t finger_Read_info(uint8_t *Buffer)
;{
_finger_Read_info:
; .FSTART _finger_Read_info
;	uint8_t Buf[32]={0};
;	if(finger_send_Command(read_product_logo,Buf,0)==0)
	RCALL SUBOPT_0xF
	SBIW R28,32
	LDI  R24,32
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x3B*2)
	LDI  R31,HIGH(_0x3B*2)
	RCALL __INITLOCB
;	*Buffer -> Y+32
;	Buf -> Y+0
	LDI  R30,LOW(128)
	RCALL SUBOPT_0x15
	LDI  R26,LOW(0)
	RCALL SUBOPT_0x16
	BRNE _0x3C
;	{
;		if(finger_Get_pack(Buf,31,200)==0)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(31)
	ST   -Y,R30
	RCALL SUBOPT_0x14
	BRNE _0x3D
;		{
;			memset(Buffer,0,25);
	LDD  R30,Y+32
	LDD  R31,Y+32+1
	RCALL SUBOPT_0x17
	LDI  R26,LOW(25)
	LDI  R27,0
	RCALL _memset
;			memcpy(Buffer,&Buf[5],24);
	LDD  R30,Y+32
	LDD  R31,Y+32+1
	RCALL SUBOPT_0xA
	MOVW R30,R28
	ADIW R30,7
	RCALL SUBOPT_0xA
	LDI  R26,LOW(24)
	LDI  R27,0
	RCALL _memcpy
;			return 0;
	LDI  R30,LOW(0)
	RJMP _0x2060009
;		}
;	}
_0x3D:
;	return 1;
_0x3C:
	LDI  R30,LOW(1)
_0x2060009:
	ADIW R28,34
	RET
;}
; .FEND
;
;
;uint8_t finger_Read_IDnum(uint8_t *Buffer)
;{
;	uint8_t Buf[32]={0};
;	if(finger_send_Command(read_id_number,Buf,0)==0)
;	*Buffer -> Y+32
;	Buf -> Y+0
;	{
;		if(finger_Get_pack(Buf,31,200)==0)
;		{
;			memset(Buffer,0,250);
;			memcpy(Buffer,&Buf[5],204);
;			return 0;
;		}
;	}
;	return 1;
;}
;
;
;uint8_t finger_Write_flash(uint16_t Adders,uint8_t *Data,uint8_t data_Len)
;{
_finger_Write_flash:
; .FSTART _finger_Write_flash
;	uint8_t AH = Adders/8;
;	uint8_t AL = Adders%8;
;	uint8_t Buffer[138];
;	Buffer[0] = AH;
	ST   -Y,R26
	SBIW R28,63
	SBIW R28,63
	SBIW R28,12
	RCALL __SAVELOCR2
;	Adders -> Y+143
;	*Data -> Y+141
;	data_Len -> Y+140
;	AH -> R17
;	AL -> R16
;	Buffer -> Y+2
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
	__GETB1SX 143
	RCALL SUBOPT_0x1A
;	Buffer[1] = AL;
;	Buffer[2] = data_Len;
	__GETB1SX 140
	STD  Y+4,R30
;	memcpy(&Buffer[3],Data,data_Len);
	MOVW R30,R28
	ADIW R30,5
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0xA
	__GETB2SX 144
	CLR  R27
	RCALL _memcpy
;	if(finger_send_Command(write_user_flash,Buffer,data_Len+3)==0)
	LDI  R30,LOW(100)
	RCALL SUBOPT_0x1B
	__GETB2SX 143
	SUBI R26,-LOW(3)
	RCALL SUBOPT_0x16
	BRNE _0x41
;	{
;		memset(Buffer,0,50);
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x17
	LDI  R26,LOW(50)
	RCALL SUBOPT_0x1D
;		if(finger_Get_pack(Buffer,31,200)==0 && Buffer[2]==0x30 && Buffer[5]==0x31)
	LDI  R30,LOW(31)
	ST   -Y,R30
	RCALL SUBOPT_0x14
	BRNE _0x43
	RCALL SUBOPT_0x1E
	BRNE _0x43
	RCALL SUBOPT_0x1F
	BREQ _0x44
_0x43:
	RJMP _0x42
_0x44:
;		{
;			return 0; /*Ok */
	LDI  R30,LOW(0)
	RJMP _0x2060008
;		}
;	}
_0x42:
;
;	return 1;
_0x41:
	LDI  R30,LOW(1)
_0x2060008:
	RCALL __LOADLOCR2
	ADIW R28,63
	ADIW R28,63
	ADIW R28,19
	RET
;}
; .FEND
;
;uint8_t finger_Read_flash(uint16_t Adders,uint8_t *Data,uint8_t data_Len)
;{
_finger_Read_flash:
; .FSTART _finger_Read_flash
;	uint8_t AH = Adders/8;
;	uint8_t AL = Adders%8;
;	uint8_t Buffer[130];
;	Buffer[0] = AH;
	ST   -Y,R26
	SBIW R28,63
	SBIW R28,63
	SBIW R28,4
	RCALL __SAVELOCR2
;	Adders -> Y+135
;	*Data -> Y+133
;	data_Len -> Y+132
;	AH -> R17
;	AL -> R16
;	Buffer -> Y+2
	__GETW1SX 135
	RCALL SUBOPT_0x19
	__GETB1SX 135
	RCALL SUBOPT_0x1A
;	Buffer[1] = AL;
;	Buffer[2] = data_Len;
	__GETB1SX 132
	STD  Y+4,R30
;
;	if(finger_send_Command(read_user_flash,Buffer,3)==0)
	LDI  R30,LOW(98)
	RCALL SUBOPT_0x1B
	LDI  R26,LOW(3)
	RCALL SUBOPT_0x16
	BRNE _0x45
;	{
;		memset(Buffer,0,130);
	RCALL SUBOPT_0x20
	LDI  R26,LOW(130)
	RCALL SUBOPT_0x1D
;		if(finger_Get_pack(Buffer,130,200)==0 && Buffer[2]==0x30 && Buffer[4]==read_user_flash)
	LDI  R30,LOW(130)
	ST   -Y,R30
	RCALL SUBOPT_0x14
	BRNE _0x47
	RCALL SUBOPT_0x1E
	BRNE _0x47
	LDD  R26,Y+6
	CPI  R26,LOW(0x62)
	BREQ _0x48
_0x47:
	RJMP _0x46
_0x48:
;		{
;			memcpy(Data,&Buffer[5],data_Len);
	__GETW1SX 133
	RCALL SUBOPT_0xA
	MOVW R30,R28
	ADIW R30,9
	RCALL SUBOPT_0xA
	__GETB2SX 136
	CLR  R27
	RCALL _memcpy
;			return 0; /*Ok */
	LDI  R30,LOW(0)
	RJMP _0x2060007
;		}
;	}
_0x46:
;	return 1;
_0x45:
	LDI  R30,LOW(1)
_0x2060007:
	RCALL __LOADLOCR2
	ADIW R28,63
	ADIW R28,63
	ADIW R28,11
	RET
;}
; .FEND
;
;
;uint8_t finger_delete(uint16_t ID)
;{
_finger_delete:
; .FSTART _finger_delete
;	uint8_t AH = ID/8;
;	uint8_t AL = ID%8;
;	uint8_t Buffer[15];
;	Buffer[0] = AH;
	RCALL SUBOPT_0x21
;	ID -> Y+17
;	AH -> R17
;	AL -> R16
;	Buffer -> Y+2
	LDD  R30,Y+17
	RCALL SUBOPT_0x1A
;	Buffer[1] = AL;
;
;	if(finger_send_Command(delet_fingerprint,Buffer,2)==0)
	LDI  R30,LOW(66)
	RCALL SUBOPT_0x1B
	LDI  R26,LOW(2)
	RCALL SUBOPT_0x16
	BRNE _0x49
;	{
;		memset(Buffer,0,15);
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x22
;		if(finger_Get_pack(Buffer,15,500)==0)
	__GETD2N 0x1F4
	RCALL SUBOPT_0x23
	BRNE _0x4A
;		{
;			if(Buffer[2]==0x30 && Buffer[4]==delet_fingerprint && Buffer[5]==0x31)
	RCALL SUBOPT_0x1E
	BRNE _0x4C
	LDD  R26,Y+6
	CPI  R26,LOW(0x42)
	BRNE _0x4C
	RCALL SUBOPT_0x1F
	BREQ _0x4D
_0x4C:
	RJMP _0x4B
_0x4D:
;				return 0; /*OK*/
	LDI  R30,LOW(0)
	RJMP _0x2060006
;
;		}
_0x4B:
;	}
_0x4A:
;	return 1;
_0x49:
	RJMP _0x2060005
;}
; .FEND
;
;uint8_t finger_add(uint16_t ID)
;{
_finger_add:
; .FSTART _finger_add
;	uint8_t AH = ID/8;
;	uint8_t AL = ID%8;
;	uint8_t Buffer[15];
;	Buffer[0] = AH;
	RCALL SUBOPT_0x21
;	ID -> Y+17
;	AH -> R17
;	AL -> R16
;	Buffer -> Y+2
	LDD  R30,Y+17
	RCALL SUBOPT_0x1A
;	Buffer[1] = AL;
;
;	if(finger_send_Command(add_fingerprint,Buffer,2)==0)
	LDI  R30,LOW(64)
	RCALL SUBOPT_0x1B
	LDI  R26,LOW(2)
	RCALL SUBOPT_0x16
	BRNE _0x4E
;	{
;		memset(Buffer,0,15);
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x22
;		if(finger_Get_pack(Buffer,15,10000)==0)
	__GETD2N 0x2710
	RCALL SUBOPT_0x23
	BRNE _0x4F
;		{
;			if(Buffer[2]==0x30 && Buffer[4]==add_fingerprint)
	RCALL SUBOPT_0x1E
	BRNE _0x51
	LDD  R26,Y+6
	CPI  R26,LOW(0x40)
	BREQ _0x52
_0x51:
	RJMP _0x50
_0x52:
;			{
;				if(Buffer[5]==0x31)
	RCALL SUBOPT_0x1F
	BRNE _0x53
;				{
;					memset(Buffer,0,15);
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x22
;					if(finger_Get_pack(Buffer,15,5000)==0)
	__GETD2N 0x1388
	RCALL SUBOPT_0x23
	BRNE _0x54
;					{
;						if(Buffer[2]==0x30 && Buffer[4]==add_fingerprint && Buffer[5]==0x31)
	RCALL SUBOPT_0x1E
	BRNE _0x56
	LDD  R26,Y+6
	CPI  R26,LOW(0x40)
	BRNE _0x56
	RCALL SUBOPT_0x1F
	BREQ _0x57
_0x56:
	RJMP _0x55
_0x57:
;							return 0; /*OK*/
	LDI  R30,LOW(0)
	RJMP _0x2060006
;					}
_0x55:
;
;				}
_0x54:
;				else if(Buffer[5]==0x33)
_0x53:
;				{
;					return 1; /*It's Timeout*/
;				}
;
;			}
_0x58:
;
;		}
_0x50:
;	}
_0x4F:
;	return 1;
_0x4E:
_0x2060005:
	LDI  R30,LOW(1)
_0x2060006:
	RCALL __LOADLOCR2
	ADIW R28,19
	RET
;}
; .FEND
;
;
;uint8_t finger_search(uint16_t Start_ID,uint16_t NumID,uint16_t *MatchID)
;{
_finger_search:
; .FSTART _finger_search
;
;	uint8_t Buffer[15];
;	Buffer[0] = Start_ID/8;
	RCALL SUBOPT_0xF
	SBIW R28,15
;	Start_ID -> Y+19
;	NumID -> Y+17
;	*MatchID -> Y+15
;	Buffer -> Y+0
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	RCALL __LSRW3
	ST   Y,R30
;	Buffer[1] = Start_ID%8;
	LDD  R30,Y+19
	ANDI R30,LOW(0x7)
	STD  Y+1,R30
;	Buffer[2] = NumID/8;
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	RCALL __LSRW3
	STD  Y+2,R30
;	Buffer[3] = NumID%8;
	LDD  R30,Y+17
	ANDI R30,LOW(0x7)
	STD  Y+3,R30
;
;	if(finger_send_Command(search_fingerprint,Buffer,4)==0)
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x15
	LDI  R26,LOW(4)
	RCALL SUBOPT_0x16
	BREQ PC+2
	RJMP _0x5A
;	{
;		memset(Buffer,0,15);
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x5
	RCALL _memset
;		if(finger_Get_pack(Buffer,15,10500)==0)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(15)
	ST   -Y,R30
	__GETD2N 0x2904
	RCALL SUBOPT_0x23
	BRNE _0x5B
;		{
;			if(Buffer[2]==0x30 && Buffer[4]==search_fingerprint)
	LDD  R26,Y+2
	CPI  R26,LOW(0x30)
	BRNE _0x5D
	LDD  R26,Y+4
	CPI  R26,LOW(0x44)
	BREQ _0x5E
_0x5D:
	RJMP _0x5C
_0x5E:
;			{
;				if(Buffer[5]==0x31) /*Found ID*/
	LDD  R26,Y+5
	CPI  R26,LOW(0x31)
	BRNE _0x5F
;				{
;					memset(Buffer,0,15);
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x5
	RCALL _memset
;					if(finger_Get_pack(Buffer,15,2000)==0)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(15)
	ST   -Y,R30
	__GETD2N 0x7D0
	RCALL SUBOPT_0x23
	BRNE _0x60
;					{
;						if(Buffer[5]==0x39)
	LDD  R26,Y+5
	CPI  R26,LOW(0x39)
	BRNE _0x61
;						{
;							*MatchID = Buffer[6]*256+Buffer[7];
	LDD  R26,Y+6
	LDI  R27,0
	LDI  R30,LOW(256)
	LDI  R31,HIGH(256)
	RCALL __MULW12
	MOVW R26,R30
	LDD  R30,Y+7
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	ST   X+,R30
	ST   X,R31
;							return 0;
	LDI  R30,LOW(0)
	RJMP _0x2060004
;						}
;						else if(Buffer[5]==0x3A)
_0x61:
	LDD  R26,Y+5
	CPI  R26,LOW(0x3A)
	BRNE _0x63
;						{
;							return Not_Found_Match_ID;
	LDI  R30,LOW(2)
	RJMP _0x2060004
;						}
;						else if(Buffer[5]==0x34)
_0x63:
	LDD  R26,Y+5
	CPI  R26,LOW(0x34)
	BRNE _0x65
;						{
;							return finger_print_is_poor;
	LDI  R30,LOW(3)
	RJMP _0x2060004
;						}
;
;					}
_0x65:
;				}
_0x60:
;				else if(Buffer[5]==0x33)
_0x5F:
;				{
;					return Req_TimeOut; /*It's Timeout*/
;				}
;
;			}
_0x66:
;		}
_0x5C:
;	}
_0x5B:
;
;	return 1;
_0x5A:
_0x2060003:
	LDI  R30,LOW(1)
_0x2060004:
	ADIW R28,21
	RET
;}
; .FEND
;
;
;
;#include <stdio.h>
;
;// Declare your global variables here
;uint8_t KeyStatus[4];
;void Tim_ISR(void)
; 0000 0021 {
_Tim_ISR:
; .FSTART _Tim_ISR
; 0000 0022 	static int i= 0;
; 0000 0023 	static int j= 0;
; 0000 0024 
; 0000 0025 	if(i++>100)
	LDI  R26,LOW(_i_S0000023000)
	LDI  R27,HIGH(_i_S0000023000)
	RCALL SUBOPT_0x10
	SBIW R30,1
	CPI  R30,LOW(0x65)
	LDI  R26,HIGH(0x65)
	CPC  R31,R26
	BRLT _0x68
; 0000 0026 	{
; 0000 0027 		i= 0;
	LDI  R30,LOW(0)
	STS  _i_S0000023000,R30
	STS  _i_S0000023000+1,R30
; 0000 0028 		KeyStatus[0] = IS_Press(KEY1_Port,KEY1_Pin);
	IN   R30,0x10
	ANDI R30,LOW(0x20)
	RCALL SUBOPT_0x24
	STS  _KeyStatus,R30
; 0000 0029 		KeyStatus[1] = IS_Press(KEY2_Port,KEY2_Pin);
	IN   R30,0x10
	ANDI R30,LOW(0x40)
	RCALL SUBOPT_0x24
	__PUTB1MN _KeyStatus,1
; 0000 002A 		KeyStatus[2] = IS_Press(KEY3_Port,KEY3_Pin);
	IN   R30,0x10
	ANDI R30,LOW(0x80)
	RCALL SUBOPT_0x24
	__PUTB1MN _KeyStatus,2
; 0000 002B 		KeyStatus[3] = IS_Press(KEY4_Port,KEY4_Pin);
	IN   R30,0x16
	ANDI R30,LOW(0x1)
	RCALL SUBOPT_0x24
	__PUTB1MN _KeyStatus,3
; 0000 002C 	}
; 0000 002D 	if(j++>5000)
_0x68:
	LDI  R26,LOW(_j_S0000023000)
	LDI  R27,HIGH(_j_S0000023000)
	RCALL SUBOPT_0x10
	SBIW R30,1
	CPI  R30,LOW(0x1389)
	LDI  R26,HIGH(0x1389)
	CPC  R31,R26
	BRLT _0x69
; 0000 002E 	{
; 0000 002F 		j = 0;
	LDI  R30,LOW(0)
	STS  _j_S0000023000,R30
	STS  _j_S0000023000+1,R30
; 0000 0030 		LEDR_Set();
	SBI  0x12,2
; 0000 0031 		delay_ms(3);
	LDI  R26,LOW(3)
	RCALL SUBOPT_0x25
; 0000 0032 		LEDR_Clr();
	CBI  0x12,2
; 0000 0033 	}
; 0000 0034 }
_0x69:
	RET
; .FEND
;
;void main(void)
; 0000 0037 {
_main:
; .FSTART _main
; 0000 0038 uint8_t resp;
; 0000 0039 uint8_t res;
; 0000 003A uint8_t i;
; 0000 003B uint16_t ID;
; 0000 003C uint8_t Info[30]={0};
; 0000 003D     char lcdstr[30];
; 0000 003E 	uint8_t Tamper[22];
; 0000 003F 
; 0000 0040 	LED_Init();
	SBIW R28,63
	SBIW R28,19
	LDI  R24,30
	LDI  R26,LOW(52)
	LDI  R27,HIGH(52)
	LDI  R30,LOW(_0x6A*2)
	LDI  R31,HIGH(_0x6A*2)
	RCALL __INITLOCB
;	resp -> R17
;	res -> R16
;	i -> R19
;	ID -> R20,R21
;	Info -> Y+52
;	lcdstr -> Y+22
;	Tamper -> Y+0
	IN   R30,0x11
	ORI  R30,LOW(0xC)
	OUT  0x11,R30
; 0000 0041 	Key_Init();
	IN   R30,0x11
	ANDI R30,LOW(0x1F)
	OUT  0x11,R30
	CBI  0x17,0
	IN   R30,0x12
	ORI  R30,LOW(0xE0)
	OUT  0x12,R30
	SBI  0x18,0
; 0000 0042 	RELE_Init();
	SBI  0x17,1
; 0000 0043 	Timer_init(Tim_ISR);
	LDI  R26,LOW(_Tim_ISR)
	LDI  R27,HIGH(_Tim_ISR)
	RCALL _Timer_init
; 0000 0044 	USART3_Config(57600);
	LDI  R26,LOW(57600)
	LDI  R27,HIGH(57600)
	RCALL _USART3_Config
; 0000 0045 	lcd_init();
	RCALL _lcd_init
; 0000 0046     delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL SUBOPT_0x26
; 0000 0047 	lcd_cls();
; 0000 0048 	delay_ms(100);
; 0000 0049 	sprintf(lcdstr,"Finger Ver:");
	MOVW R30,R28
	ADIW R30,22
	RCALL SUBOPT_0xA
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0x27
; 0000 004A     lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xE
; 0000 004B 	lcd_puts(lcdstr);
	MOVW R26,R28
	ADIW R26,22
	RCALL _lcd_puts
; 0000 004C 
; 0000 004D 	if(!finger_Read_info(Info))
	MOVW R26,R28
	ADIW R26,52
	RCALL _finger_Read_info
	CPI  R30,0
	BRNE _0x6B
; 0000 004E 	{
; 0000 004F         sprintf(lcdstr,"%s",Info);
	MOVW R30,R28
	ADIW R30,22
	RCALL SUBOPT_0xA
	__POINTW1FN _0x0,12
	RCALL SUBOPT_0xA
	MOVW R30,R28
	ADIW R30,56
	RCALL SUBOPT_0x28
; 0000 0050         lcd_gotoxy(0, 1)  ;
	RCALL SUBOPT_0x29
; 0000 0051 		lcd_puts(lcdstr);
	MOVW R26,R28
	ADIW R26,22
	RCALL _lcd_puts
; 0000 0052 	}
; 0000 0053 	else
	RJMP _0x6C
_0x6B:
; 0000 0054 	{
; 0000 0055         lcd_gotoxy(0, 1)  ;
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x29
; 0000 0056 		lcd_puts("Read Error");
	__POINTW2MN _0x6D,0
	RCALL _lcd_puts
; 0000 0057 		while(1);
_0x6E:
	RJMP _0x6E
; 0000 0058 	}
_0x6C:
; 0000 0059 	delay_ms(3000);
	LDI  R26,LOW(3000)
	LDI  R27,HIGH(3000)
	RCALL SUBOPT_0x26
; 0000 005A 	lcd_cls();
; 0000 005B 	delay_ms(100);
; 0000 005C 
; 0000 005D       lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
; 0000 005E 		lcd_puts("Wait For Finger");
	__POINTW2MN _0x6D,11
	RCALL _lcd_puts
; 0000 005F 
; 0000 0060 
; 0000 0061 
; 0000 0062 while(1)
_0x71:
; 0000 0063     {
; 0000 0064 
; 0000 0065         uint8_t resp = finger_search(0,20,&ID);
; 0000 0066 
; 0000 0067         if(resp==0)
	SBIW R28,1
;	Info -> Y+53
;	lcdstr -> Y+23
;	Tamper -> Y+1
;	resp -> Y+0
	RCALL SUBOPT_0x2A
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0xA
	IN   R26,SPL
	IN   R27,SPH
	SBIW R26,1
	PUSH R21
	PUSH R20
	RCALL _finger_search
	POP  R20
	POP  R21
	ST   Y,R30
	RCALL SUBOPT_0x0
	BRNE _0x74
; 0000 0068         {
; 0000 0069             lcd_cls();
	RCALL SUBOPT_0x2B
; 0000 006A             delay_ms(100);
; 0000 006B             sprintf(lcdstr,"Finger %i Valid",ID);
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,42
	RCALL SUBOPT_0xA
	MOVW R30,R20
	RCALL SUBOPT_0x28
; 0000 006C             lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xE
; 0000 006D 		    lcd_puts(lcdstr);
	RCALL SUBOPT_0x2D
; 0000 006E 
; 0000 006F             Rele_Set();
	SBI  0x18,1
; 0000 0070             LEDG_Set();
	SBI  0x12,3
; 0000 0071             delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 0072 			LEDG_Clr();
	CBI  0x12,3
; 0000 0073 			Rele_Clr();
	CBI  0x18,1
; 0000 0074 			delay_ms(1000);
	RJMP _0x8E
; 0000 0075 		}
; 0000 0076 		else if(resp==Not_Found_Match_ID)
_0x74:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0x76
; 0000 0077 		{
; 0000 0078 			lcd_cls();
	RCALL SUBOPT_0x2B
; 0000 0079 			delay_ms(100);
; 0000 007A 			sprintf(lcdstr,"Finger Not Valid");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,58
	RCALL SUBOPT_0x27
; 0000 007B             lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xE
; 0000 007C 		    lcd_puts(lcdstr) ;
	RCALL SUBOPT_0x2D
; 0000 007D 			LEDR_Set();
	SBI  0x12,2
; 0000 007E 			delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 007F 			LEDR_Clr();
	CBI  0x12,2
; 0000 0080 			delay_ms(1000);
_0x8E:
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
; 0000 0081 
; 0000 0082 		}
; 0000 0083 
; 0000 0084 
; 0000 0085 		if(KeyStatus[0]) /*Reg New Finger*/
_0x76:
	LDS  R30,_KeyStatus
	CPI  R30,0
	BREQ _0x77
; 0000 0086 		{
; 0000 0087 			lcd_cls();
	RCALL SUBOPT_0x2B
; 0000 0088 			delay_ms(100);
; 0000 0089 			sprintf(lcdstr,"Reg Finger...");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,75
	RCALL SUBOPT_0x27
; 0000 008A 			lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xE
; 0000 008B 		    lcd_puts(lcdstr) ;
	RCALL SUBOPT_0x2D
; 0000 008C             delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 008D 			finger_Read_flash(0,Tamper,20);
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2F
	RCALL _finger_Read_flash
; 0000 008E 
; 0000 008F 			for(i=0;i<20;i++)
	LDI  R19,LOW(0)
_0x79:
	CPI  R19,20
	BRSH _0x7A
; 0000 0090 			{
; 0000 0091 				 if(Tamper[i]!=0xa5)
	RCALL SUBOPT_0x30
	LD   R26,X
	CPI  R26,LOW(0xA5)
	BRNE _0x7A
; 0000 0092 					 break;
; 0000 0093 			}
	SUBI R19,-1
	RJMP _0x79
_0x7A:
; 0000 0094 
; 0000 0095 			if(i>20)
	CPI  R19,21
	BRLO _0x7C
; 0000 0096 			{
; 0000 0097 				 sprintf(lcdstr,"Memory Is Full");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,89
	RJMP _0x8F
; 0000 0098                  lcd_gotoxy(0, 1)  ;
; 0000 0099 		         lcd_puts(lcdstr) ;
; 0000 009A 				 delay_ms(2000);
; 0000 009B 			}
; 0000 009C 			else
_0x7C:
; 0000 009D 			{
; 0000 009E 				Tamper[i] = 0xa5;
	RCALL SUBOPT_0x30
	LDI  R30,LOW(165)
	ST   X,R30
; 0000 009F 				res = finger_add(i);
	MOV  R26,R19
	CLR  R27
	RCALL _finger_add
	MOV  R16,R30
; 0000 00A0 				if(res==0)
	CPI  R16,0
	BRNE _0x7E
; 0000 00A1 				{
; 0000 00A2 					finger_Write_flash(0,Tamper,20);
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2F
	RCALL _finger_Write_flash
; 0000 00A3 					sprintf(lcdstr,"Add in ID:%i->%i",i);
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,104
	RCALL SUBOPT_0x31
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 00A4                     lcd_gotoxy(0, 1)  ;
	RJMP _0x90
; 0000 00A5 		            lcd_puts(lcdstr);
; 0000 00A6 				}
; 0000 00A7 				else
_0x7E:
; 0000 00A8 				{
; 0000 00A9 					sprintf(lcdstr,"Add Faild.");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,121
_0x8F:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00AA                     lcd_gotoxy(0, 1)  ;
_0x90:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL SUBOPT_0x29
; 0000 00AB 		            lcd_puts(lcdstr)  ;
	RCALL SUBOPT_0x2D
; 0000 00AC 				}
; 0000 00AD 				delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	RCALL _delay_ms
; 0000 00AE 			}
; 0000 00AF 		}
; 0000 00B0 		else if(KeyStatus[1]) /*Remove One Section*/
	RJMP _0x80
_0x77:
	__GETB1MN _KeyStatus,1
	CPI  R30,0
	BRNE PC+2
	RJMP _0x81
; 0000 00B1 		{
; 0000 00B2 			lcd_cls();
	RCALL SUBOPT_0x2B
; 0000 00B3 			delay_ms(100);
; 0000 00B4 			sprintf(lcdstr,"Remove Finger...");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,132
	RCALL SUBOPT_0x27
; 0000 00B5             lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xE
; 0000 00B6 		    lcd_puts(lcdstr) ;
	RCALL SUBOPT_0x2D
; 0000 00B7 			delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 00B8 			resp = finger_search(0,20,&ID);
	RCALL SUBOPT_0x2A
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0xA
	IN   R26,SPL
	IN   R27,SPH
	SBIW R26,1
	PUSH R21
	PUSH R20
	RCALL _finger_search
	POP  R20
	POP  R21
	ST   Y,R30
; 0000 00B9 			if(resp==0)
	RCALL SUBOPT_0x0
	BRNE _0x82
; 0000 00BA 			{
; 0000 00BB 				finger_Read_flash(0,Tamper,20);
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2F
	RCALL _finger_Read_flash
; 0000 00BC 				Tamper[ID] = 0xFF; /*Free This*/
	MOVW R26,R28
	ADIW R26,1
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(255)
	ST   X,R30
; 0000 00BD 				if(!finger_delete(ID))
	MOVW R26,R20
	RCALL _finger_delete
	CPI  R30,0
	BRNE _0x83
; 0000 00BE 				{
; 0000 00BF 					finger_Write_flash(0,Tamper,20);
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2F
	RCALL _finger_Write_flash
; 0000 00C0 					sprintf(lcdstr,"Remove %i Ok",ID);
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,149
	RCALL SUBOPT_0xA
	MOVW R30,R20
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 00C1                     lcd_gotoxy(0, 1)  ;
	RJMP _0x91
; 0000 00C2 		            lcd_puts(lcdstr);
; 0000 00C3 				}
; 0000 00C4 				else
_0x83:
; 0000 00C5 				{
; 0000 00C6 					sprintf(lcdstr,"Remove Faild");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,162
	RCALL SUBOPT_0xA
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00C7                     lcd_gotoxy(0, 1)  ;
_0x91:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL SUBOPT_0x29
; 0000 00C8 		            lcd_puts(lcdstr);
	RCALL SUBOPT_0x2D
; 0000 00C9 				}
; 0000 00CA 			}
; 0000 00CB 			else
	RJMP _0x85
_0x82:
; 0000 00CC 			{
; 0000 00CD 				sprintf(lcdstr,"Remove Faild");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,162
	RCALL SUBOPT_0x27
; 0000 00CE                 lcd_gotoxy(0, 1)  ;
	RCALL SUBOPT_0x29
; 0000 00CF 		        lcd_puts(lcdstr) ;
	RCALL SUBOPT_0x2D
; 0000 00D0 			}
_0x85:
; 0000 00D1 			delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	RCALL _delay_ms
; 0000 00D2 		}
; 0000 00D3 		else if(KeyStatus[2])
	RJMP _0x86
_0x81:
	__GETB1MN _KeyStatus,2
	CPI  R30,0
	BREQ _0x87
; 0000 00D4 		{
; 0000 00D5 			lcd_cls();
	RCALL SUBOPT_0x2B
; 0000 00D6 			delay_ms(100);
; 0000 00D7 			sprintf(lcdstr,"Remove All Finger");
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,175
	RCALL SUBOPT_0x27
; 0000 00D8             lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xE
; 0000 00D9 		    lcd_puts(lcdstr) ;
	RCALL SUBOPT_0x2D
; 0000 00DA 			delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 00DB 			for(i=0;i<20;i++)
	LDI  R19,LOW(0)
_0x89:
	CPI  R19,20
	BRSH _0x8A
; 0000 00DC 			{
; 0000 00DD 				Tamper[i] = 0xFF;
	RCALL SUBOPT_0x30
	LDI  R30,LOW(255)
	ST   X,R30
; 0000 00DE 				 sprintf(lcdstr,"RemoveID:%i->%i",i,finger_delete(i));
	RCALL SUBOPT_0x2C
	__POINTW1FN _0x0,193
	RCALL SUBOPT_0x31
	MOV  R26,R19
	CLR  R27
	RCALL _finger_delete
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
; 0000 00DF                  lcd_gotoxy(0, 1)  ;
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x29
; 0000 00E0 		         lcd_puts(lcdstr) ;
	RCALL SUBOPT_0x2D
; 0000 00E1 				 delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 00E2 			}
	SUBI R19,-1
	RJMP _0x89
_0x8A:
; 0000 00E3 			finger_Write_flash(0,Tamper,20);
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2F
	RCALL _finger_Write_flash
; 0000 00E4 		}
; 0000 00E5 
; 0000 00E6 
; 0000 00E7 		lcd_cls();
_0x87:
_0x86:
_0x80:
	RCALL _lcd_cls
; 0000 00E8 		delay_ms(50);
	LDI  R26,LOW(50)
	RCALL SUBOPT_0x25
; 0000 00E9         lcd_gotoxy(0, 0)  ;
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
; 0000 00EA 		lcd_puts("Wait For Finger");
	__POINTW2MN _0x6D,27
	RCALL _lcd_puts
; 0000 00EB 		//LEDR_Tog();
; 0000 00EC 		delay_ms(50);
	LDI  R26,LOW(50)
	RCALL SUBOPT_0x25
; 0000 00ED 	}
	ADIW R28,1
	RJMP _0x71
; 0000 00EE }
_0x8B:
	RJMP _0x8B
; .FEND

	.DSEG
_0x6D:
	.BYTE 0x2B

	.CSEG
_memcpy:
; .FSTART _memcpy
	RCALL SUBOPT_0xF
    ldd  r25,y+1
    ld   r24,y
    adiw r24,0
    breq memcpy1
    ldd  r27,y+5
    ldd  r26,y+4
    ldd  r31,y+3
    ldd  r30,y+2
memcpy0:
    ld   r22,z+
    st   x+,r22
    sbiw r24,1
    brne memcpy0
memcpy1:
    ldd  r31,y+5
    ldd  r30,y+4
	ADIW R28,6
	RET
; .FEND
_memset:
; .FSTART _memset
	RCALL SUBOPT_0xF
    ldd  r27,y+1
    ld   r26,y
    adiw r26,0
    breq memset1
    ldd  r31,y+4
    ldd  r30,y+3
    ldd  r22,y+2
memset0:
    st   z+,r22
    sbiw r26,1
    brne memset0
memset1:
    ldd  r30,y+3
    ldd  r31,y+4
	RJMP _0x2060002
; .FEND
_strlen:
; .FSTART _strlen
	RCALL SUBOPT_0xF
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
; .FEND
_strlenf:
; .FSTART _strlenf
	RCALL SUBOPT_0xF
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
; .FSTART _put_buff_G101
	RCALL SUBOPT_0xF
	RCALL __SAVELOCR2
	RCALL SUBOPT_0xC
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x32
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	RCALL SUBOPT_0xC
	ADIW R26,2
	RCALL SUBOPT_0x10
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
_0x2020013:
	RCALL SUBOPT_0xC
	RCALL __GETW1P
	TST  R31
	BRMI _0x2020014
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x10
_0x2020014:
	RJMP _0x2020015
_0x2020010:
	RCALL SUBOPT_0xC
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	RCALL __LOADLOCR2
_0x2060002:
	ADIW R28,5
	RET
; .FEND
__print_G101:
; .FSTART __print_G101
	RCALL SUBOPT_0xF
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	RCALL SUBOPT_0x11
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	RCALL SUBOPT_0x33
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	RCALL SUBOPT_0x33
	RJMP _0x20200CC
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x34
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x36
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	RCALL SUBOPT_0x3A
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	RCALL SUBOPT_0x3A
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x3B
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x3B
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x3B
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	RCALL SUBOPT_0x33
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	RCALL SUBOPT_0x3A
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	RCALL SUBOPT_0x33
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x3A
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x3B
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CD
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CD:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x36
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	RCALL SUBOPT_0x33
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x36
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200CC:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	RCALL SUBOPT_0x11
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
; .FEND
_sprintf:
; .FSTART _sprintf
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x3C
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2060001
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x3A
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0xA
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	RCALL SUBOPT_0xA
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2060001:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
; .FEND

	.CSEG

	.DSEG
_SYSTime:
	.BYTE 0x4
_TFix_S0000011000:
	.BYTE 0x1
_rx3_buffer:
	.BYTE 0x40
_rx3_wr_index:
	.BYTE 0x2
_rx3_rd_index:
	.BYTE 0x2
_rx3_counter:
	.BYTE 0x2
_rx3_buffer_overflow:
	.BYTE 0x1
_KeyStatus:
	.BYTE 0x4
_i_S0000023000:
	.BYTE 0x2
_j_S0000023000:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LD   R30,Y
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	SBIW R28,16
	LDI  R24,16
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	RCALL _SetLCD_EN
	__DELAY_USB 27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	RCALL _SetLCD_RS
	__DELAY_USB 27
	LD   R26,Y
	RJMP _lcd_write_byte

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(15)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6:
	RCALL _delay_ms
	LDI  R26,LOW(48)
	RJMP _lcd_command

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(1)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	RCALL _delay_ms
	LDI  R26,LOW(2)
	RCALL _lcd_command
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	RCALL _lcd_command
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 73 TIMES, CODE SIZE REDUCTION:70 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB:
	MOVW R30,R28
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xC:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(0)
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xF:
	ST   -Y,R27
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x10:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	MOVW R30,R16
	LDD  R26,Y+25
	LDD  R27,Y+25+1
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x13:
	RCALL SUBOPT_0xA
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x14:
	__GETD2N 0xC8
	RCALL _finger_Get_pack
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,1
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	RCALL _finger_send_Command
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0xA
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	__GETW1SX 143
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	RCALL __LSRW3
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1A:
	ANDI R30,LOW(0x7)
	MOV  R16,R30
	__PUTBSR 17,2
	MOVW R30,R28
	ADIW R30,3
	ST   Z,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1B:
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1C:
	MOVW R30,R28
	ADIW R30,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDI  R27,0
	RCALL _memset
	RCALL SUBOPT_0x1C
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	LDD  R26,Y+4
	CPI  R26,LOW(0x30)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDD  R26,Y+7
	CPI  R26,LOW(0x31)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	RCALL SUBOPT_0x1C
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	RCALL SUBOPT_0xF
	SBIW R28,15
	RCALL __SAVELOCR2
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	RCALL _memset
	RCALL SUBOPT_0x1C
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x23:
	RCALL _finger_Get_pack
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	LDI  R26,LOW(0)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x25:
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	RCALL _delay_ms
	RCALL _lcd_cls
	LDI  R26,LOW(100)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x27:
	RCALL SUBOPT_0xA
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x28:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	LDI  R26,LOW(1)
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2B:
	RCALL _lcd_cls
	LDI  R26,LOW(100)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x2C:
	MOVW R30,R28
	ADIW R30,23
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2D:
	MOVW R26,R28
	ADIW R26,23
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDI  R26,LOW(100)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2F:
	MOVW R30,R28
	ADIW R30,3
	RCALL SUBOPT_0xA
	LDI  R26,LOW(20)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x30:
	MOV  R30,R19
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,1
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	RCALL SUBOPT_0xA
	MOV  R30,R19
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x32:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x33:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x35:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x36:
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	RCALL SUBOPT_0x34
	RJMP SUBOPT_0x35

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x38:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0x32

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x39:
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3A:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3B:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3C:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
