/*
 * Timer.c
 *
 *  Created on: Oct 31, 2014
 *      Author: Zeus @ Sisoog.com
 */

#include <stdint.h>

void (*ISR_CallBack)(void);
volatile uint32_t SYSTime = 0;

interrupt [TIM2_COMP] void timer2_comp_isr(void)
{
	static uint8_t TFix = 0;
	if(TFix++>10)
	{
		TFix = 0;
		SYSTime++;
	}
	if(ISR_CallBack)
		ISR_CallBack();
}


void Timer_init(void (*CallBack)(void))
{
	ISR_CallBack = CallBack;

	// set timer0 counter initial value to 0
	TCNT2=0x00;
	OCR2 = 0x2A;

	// start timer2 with /1024 prescaler
	TCCR2 = (1 << WGM21) | (1<<CS22) | (1<<CS20);

	// enable timer CTC interrupt for Timer0
	TIMSK=(1<<OCIE2);
}
